<?php
function loadaddressinfo($datafile,&$addressinfo)
{
	global $datacover_symbol, $separator;

	clearstatcache();
	$lastcache=@filemtime($datafile);

	if(isset($_SESSION['addressinfo_cache']) && $_SESSION['addressinfo_cache']['lastcache']==$lastcache) 
	{
		$addressinfo=$_SESSION['addressinfo_cache'];
		return true;
  }
  
        $lineunit=6;
        if(!file_exists($datafile))
        {
                $h=fopen($datafile,'w');
                if($h)
                {
                        fwrite($h,$datacover_symbol[0]."\n");
                        fwrite($h,$datacover_symbol[1]."\n");
                        fclose($h);
                }
        }
        if(!file_exists($datafile)) return false;

        $lines=file($datafile);
        $num=(count($lines)-2)/$lineunit;

	$idarr=array();
	$lastarr=array();
	$namearr=array();
	$categoryarr=array();
	$birthdayarr=array();
	$phonearr=array();
	$emailarr=array();
	$otherarr=array();
	$addressinfo=array();
	for($i=0;$i<$num;$i++)
	{
		$str=explode($separator,$lines[$i*$lineunit+1]);
		array_push($idarr,$str[0]);
		array_push($lastarr,$str[1]);
		$str=explode($separator,$lines[$i*$lineunit+2]);
		array_push($categoryarr,$str[0]);
		array_push($namearr,$str[1]);
		$str=explode($separator,$lines[$i*$lineunit+3]);
		array_push($birthdayarr,$str[0]);
		$str=explode($separator,$lines[$i*$lineunit+4]);
		array_push($phonearr,$str[0]);
		$str=explode($separator,$lines[$i*$lineunit+5]);
		array_push($emailarr,$str[0]);
		$str=explode($separator,$lines[$i*$lineunit+6]);
		array_push($otherarr,$str[0]);
	}

	$addressinfo=array("id"=>$idarr,
			"lastmod"=>$lastarr,
			"category"=>$categoryarr,
			"name"=>$namearr,
			"birthday"=>$birthdayarr,
			"phone"=>$phonearr,
			"email"=>$emailarr,
			"other"=>$otherarr,
			"lastcache"=>$lastcache);
	$_SESSION['addressinfo_cache']=$addressinfo;
	return true;
}

function writeaddressinfo($datafile,$addressinfo,$mode)
{
	global $datacover_symbol, $separator;
	$lineunit=6;
	$alladdress=array();
	$start=0;
	if(loadaddressinfo($datafile,$alladdress)===false) return false;
	switch($mode)
	{
		case 0://add
		  array_push($alladdress['id'],$addressinfo['id']);
		  array_push($alladdress['lastmod'],$addressinfo['lastmod']);
		  array_push($alladdress['category'],$addressinfo['category']);
		  array_push($alladdress['name'],$addressinfo['name']);
		  array_push($alladdress['birthday'],$addressinfo['birthday']);
		  array_push($alladdress['phone'],$addressinfo['phone']);
		  array_push($alladdress['email'],$addressinfo['email']);
		  array_push($alladdress['other'],$addressinfo['other']);
		  break;
		case 1://mod
		  $n=array_search($addressinfo['id'],$alladdress['id']);
		  if($n===false) return false;
		  $alladdress['lastmod'][$n]=$addressinfo['lastmod'];
		  $alladdress['category'][$n]=$addressinfo['category'];
		  $alladdress['name'][$n]=$addressinfo['name'];
		  $alladdress['birthday'][$n]=$addressinfo['birthday'];
		  $alladdress['phone'][$n]=$addressinfo['phone'];
		  $alladdress['email'][$n]=$addressinfo['email'];
		  $alladdress['other'][$n]=$addressinfo['other'];
		  break;
		case 2://del
		  $n=array_search($addressinfo['id'],$alladdress['id']);
		  if($n===false) return false;
		  if($n>0)
		  {
			$alladdress['id'][$n]=$alladdress['id'][0];
			$alladdress['lastmod'][$n]=$alladdress['lastmod'][0];
			$alladdress['category'][$n]=$alladdress['category'][0];
			$alladdress['name'][$n]=$alladdress['name'][0];
			$alladdress['birthday'][$n]=$alladdress['birthday'][0];
			$alladdress['phone'][$n]=$alladdress['phone'][0];
			$alladdress['email'][$n]=$alladdress['email'][0];
			$alladdress['other'][$n]=$alladdress['other'][0];
		  }
		  $start=1;
		  break;
	}
	$h=fopen($datafile,'w');
	if($h)
	{
		fwrite($h,$datacover_symbol[0]."\n");
		for($i=$start;$i<count($alladdress['id']);$i++)
		{
			fwrite($h,$alladdress['id'][$i].$separator.$alladdress['lastmod'][$i].$separator."\n");
			fwrite($h,$alladdress['category'][$i].$separator.$alladdress['name'][$i].$separator."\n");
			fwrite($h,$alladdress['birthday'][$i].$separator."\n");
			fwrite($h,$alladdress['phone'][$i].$separator."\n");
			fwrite($h,$alladdress['email'][$i].$separator."\n");
			fwrite($h,$alladdress['other'][$i].$separator."\n");
		}		
                fwrite($h,$datacover_symbol[1]."\n");
		fclose($h);
		return true;
	}
	else return false;
}

function get_category()
{
	global $categorydatafile;
	$lines=file($categorydatafile);
	$arr=explode(":",$lines[0]);
	$category=array();
	for($i=0;$i<count($arr)-1;$i++)
	{
		$str=explode("|",$arr[$i]);
		$code="c".array_shift($str);
		$element=array($code=>$str);
		$category=array_merge($category,$element);
	}
	return $category;
}
?>
