<?php
//schedule designed by Yuming Wang (ymwang@ustc.edu.cn)
//2005-11-19  first version
//2005-12-26  add: automatically send a reminder
//2005-12-27  improve
//2006-01-16  add: Lunar date
//2006-01-22  add: Festival
//2006-01-24  bug: 2038bug fixed
//2006-04-21	some improvements

session_start();
include("../config.php");

if(isset($gp_year) && $gp_year!="") array_push($newoptions,"year=$gp_year");
else $gp_year=date("Y");
if(isset($gp_month) && $gp_month!="") array_push($newoptions,"month=$gp_month");
else $gp_month=date("n");
if(isset($gp_yearsel) && $gp_yearsel!="") array_push($newoptions,"yearsel=$gp_yearsel");
else $gp_yearsel=date("Y");
if(isset($gp_monthsel) && $gp_monthsel!="") array_push($newoptions,"monthsel=$gp_monthsel");
else $gp_monthsel=date("n");
if(isset($gp_daysel) && $gp_daysel!="") array_push($newoptions,"daysel=$gp_daysel");
else $gp_daysel=date("j");
if(isset($gp_festivalcatalog) && $gp_festivalcatalog!="") array_push($newoptions,"daysel=$gp_festivalcatalog");
else $gp_festivalcatalog=0;
if(isset($gp_display_updatepanel)) array_push($newoptions,"display_updatepanel=$gp_display_updatepanel");
else $gp_display_updatepanel=0;

include($authpage);
if(file_exists("config.php")) include("config.php");
include("schedule_func.php");

if(isset($gp_entrance) && strlen($gp_entrance)>2) 
{
	$datafile="$userhomedir/$gp_entrance/$cursubpath/$datafile";
	if(!is_dir("$userhomedir/$gp_entrance/$cursubpath"))
	{
		mkdir("$userhomedir/$gp_entrance/$cursubpath");
		touch("$userhomedir/$gp_entrance/$cursubpath/index.html");
	}
}

$year=min(max($gp_year,$startyear),$endyear);
$month=min(max($gp_month,1),12);
$mlen=$monthlength[$month-1];
if($month==2 && $year%4==0) $mlen=29;
$yearsel=min(max($gp_yearsel,$startyear),$endyear);
$monthsel=min(max($gp_monthsel,1),12);
$msellen=$monthlength[$monthsel-1];
if($monthsel==2 && $yearsel%4==0) $msellen=29;
$daysel=min(max($gp_daysel,1),$msellen);
$festivalcatalog=$gp_festivalcatalog;
include("$configpool/festivals.php");
include("$libdir/calendar_func.php");

if($gp_updatetype>0)
{
	$gp_event=trim($gp_event);
	if($gp_updatetype==1 && $gp_event!="") //add 
	{
		$gp_updateid=gmdate("YmdHis").rand_ns(3);
		$gp_startdate=$gp_startyear;
		if($gp_startmonth<10) $gp_startdate.="0";
		$gp_startdate.=$gp_startmonth;
		if($gp_startday<10) $gp_startdate.="0";
		$gp_startdate.=$gp_startday;
		$gp_enddate=$gp_endyear;
		if($gp_endmonth<10) $gp_enddate.="0";
		$gp_enddate.=$gp_endmonth;
		if($gp_endday<10) $gp_enddate.="0";
		$gp_enddate.=$gp_endday;
		if(strlen($gp_hour)==1) $gp_time="0"; else $gp_time="";
		$gp_time.=$gp_hour;
		if(strlen($gp_minute)==1) $gp_time.="0";
		$gp_time.=$gp_minute;
		switch($gp_period)
		{
			case "month":
				$gp_dop=$gp_pdop*$gp_dop;
				break;
			case "syear":
			case "lyear":
				$gp_dop="$gp_pdop.$gp_dop";
				break;
			default:
		}
		$event_str=array("id"=>$gp_updateid,
										"level"=>$gp_level,
										"share"=>rawurlencode(trim($gp_share)),
										"reminder"=>$gp_reminder,
										"category"=>$gp_category,
										"startdate"=>$gp_startdate,
										"enddate"=>$gp_enddate,
										"time"=>$gp_time,
										"dop"=>$gp_dop,
										"period"=>$gp_period,
										"event"=>rawurlencode($gp_event)
										);
		$res=write_data($datafile,$event_str,1,$errinfo);
		if($res) echo "<font color=green>An event has been successfully added into the database.</font><br>";
		else echo "<font color=red>$errinfo</font><br>";
	}
	elseif($gp_updatetype==2 && $gp_updateid!="") //mod
	{
		if($gp_event=="")	//pre mod
		{
			$res=read_data($datafile, $events, $errinfo,$year,$month,array(1,0),array($gp_updateid));
			if($res==false)
			{
				echo "<font color=red>$errinfo</font><br>";
			}
			else
			{
				$preid=$events['selectedevent']['id'][0];
				$prelevel=$events['selectedevent']['level'][0];
				$preshare=$events['selectedevent']['share'][0];
				$prereminder=$events['selectedevent']['reminder'][0];
				$precategory=$events['selectedevent']['category'][0];
				$prestartdate=$events['selectedevent']['startdate'][0];
				$prestartyear=substr($prestartdate,0,4);
				$prestartmonth=substr($prestartdate,4,2);
				$prestartday=substr($prestartdate,6,2);
				$preenddate=$events['selectedevent']['enddate'][0];
				$preendyear=substr($preenddate,0,4);
				$preendmonth=substr($preenddate,4,2);
				$preendday=substr($preenddate,6,2);
				$pretime=$events['selectedevent']['time'][0];
				$prehour=substr($pretime,0,2);
				$preminute=substr($pretime,2,2);
				$predop=$events['selectedevent']['dop'][0];
				$preperiod=$events['selectedevent']['period'][0];
				switch($preperiod)
				{
					case "month":
						$prepdop=$predop/(abs($predop));
						$predop=abs($predop);
						break;
					case "syear":
					case "lyear":
						$pos=strpos($predop,".");
						$prepdop=substr($predop,0,$pos);
						$predop=substr($predop,$pos+1);
						break;
				}
				$preevent=$events['selectedevent']['event'][0];
				$preupdatetype=2;
				$presubmitname="To Modidy";
			}
		}
		else //do mod
		{
			$gp_startdate=$gp_startyear;
			if($gp_startmonth<10) $gp_startdate.="0";
			$gp_startdate.=$gp_startmonth;
			if($gp_startday<10) $gp_startdate.="0";
			$gp_startdate.=$gp_startday;
			$gp_enddate=$gp_endyear;
			if($gp_endmonth<10) $gp_enddate.="0";
			$gp_enddate.=$gp_endmonth;
			if($gp_endday<10) $gp_enddate.="0";
			$gp_enddate.=$gp_endday;
			if(strlen($gp_hour)==1) $gp_time="0"; else $gp_time="";
			$gp_time.=$gp_hour;
			if(strlen($gp_minute)==1) $gp_time.="0";
			$gp_time.=$gp_minute;
			switch($gp_period)
			{
				case "month":
					$gp_dop=$gp_pdop*$gp_dop;
					break;
				case "syear":
				case "lyear":
					$gp_dop="$gp_pdop.$gp_dop";
					break;
				default:
			}
			$event_str=array("id"=>$gp_updateid,
											"level"=>$gp_level,
											"share"=>rawurlencode(trim($gp_share)),
											"reminder"=>$gp_reminder,
											"category"=>$gp_category,
											"startdate"=>$gp_startdate,
											"enddate"=>$gp_enddate,
											"time"=>$gp_time,
											"dop"=>$gp_dop,
											"period"=>$gp_period,
											"event"=>rawurlencode($gp_event)
											);
			$res=write_data($datafile,$event_str,2,$errinfo);
			if($res) echo "<font color=green>The event has been successfully modified.</font><br>";
			else echo "<font color=red>$errinfo</font><br>";
		}
	}
	elseif($gp_updatetype==3 && $gp_updateid!="") //del
	{
		$event_str=array("id"=>$gp_updateid);
		$res=write_data($datafile,$event_str,3,$errinfo);
		if($res) echo "<font color=green>The event has been successfully removed.</font><br>";
		else echo "<font color=red>$errinfo</font><br>";		
	}
	elseif($gp_updateid!="") echo "<font color=red>Invalid operation!</font><br>";
}

$res=read_data($datafile, $events, $errinfo, $year, $month, array(-1,1), null, array(mktime(0,0,0,$monthsel,$daysel,$yearsel)));
if($res==false)
{
	echo "<font color=red>Error when loading data: $errinfo</font><br>";
}

$a = new calendar_month($year,$month);
$a->festivalcatalog=$festivalcatalog;

if(substr($pagewidth,-1)=='%') $percent=1; else $percent=0;
$colwidth=$pagewidth/2.;
if($percent==1) $colwidth.='%';
echo "<table border=0 width=\"$pagewidth\"><tr><td colspan=2>";
echo "&nbsp;&nbsp;";
echo "<input type=button value=\"reset\" onclick=\"resetmonth();\"> ";
echo "<input type=button value=\"&lt;-\" onclick=\"movemonth(-1);\">";
echo "<select size=1 onchange=\"jumpmonth(this.options[this.selectedIndex].value);\">";
for($i=$startyear;$i<=$endyear;$i++)
{
  if($i==$year)	echo "<option selected value=$i>$i</option>";
  else	echo "<option value=$i>$i</option>";
}
echo "</select>";
echo "<select size=1 onchange=\"jumpmonth(this.options[this.selectedIndex].value);\">";
for($i=1;$i<=12;$i++)
{
  if($i==$month) echo "<option selected value=$i>$i</option>";
  else  echo "<option value=$i>$i</option>";
}
echo "</select>";
echo "<input type=button value=\"-&gt;\" onclick=\"movemonth(1);\">";
echo " <select size=1 onchange=\"changefestivalcatalog(this.options[this.selectedIndex].value);\">";
for($i=0;$i<count($festivalcatalogs);$i++)
{
	if($i==$festivalcatalog) echo "<option selected value=\"$i\">".$festivalcatalogs[$i][$language]."</option>";
	else echo "<option value=\"$i\">".$festivalcatalogs[$i][$language]."</option>";
}
echo "</select>";

echo "</td></tr><tr><td width=\"$colwidth\" valign=top>";
echo "<table border=0 width=100%><tr><td colspan=2>";
$a->show();
$a->fontsize="80%";
echo "</td></tr><tr><td width=50% valign=top>";
if($month==1) 
{
	$a->year--;
	$a->month=12;
}
else $a->month--;
$a->show_brief();
echo "</td><td width=50% valign=top>";
if($month>=11) 
{
	$a->year++;
	$a->month=1;
}
else $a->month+=2;
$a->show_brief();
echo "</td></tr></table>";

echo "</td><td width=\"$colwidth\" valign=top>";
//$b=new calendar_dayinfo($gp_yearsel,$gp_monthsel,$gp_daysel);
$b=new calendar_dayinfo($yearsel,$monthsel,$daysel);
$daydes=$b->daydes($festivalcatalog);
if($_SESSION['permission']==2) echo "<form name=\"update_schedule\" action=\"$curlinkfull\" method=\"post\">";
echo "<table cellspacing=0 border=0 width=100%><tr><td id=\"dateinfo1\" style=\"border-bottom:  1px $bordercolor solid;\">".$daydes[0]."</td><td align=right style=\"border-bottom: 1px solid $bordercolor;\">";
if($_SESSION['permission']==2) echo "<input type=button value=\"".$edit_label[$gp_display_updatepanel][$language]."\" onclick=\"displaypanel(".(1-$gp_display_updatepanel).");\">";
echo "</td></tr><tr><td id=\"dateinfo2\" colspan=2 width=100% style=\"font-size: 80%\">".$daydes[1]."</td></tr>";
if($_SESSION['permission']==2)
{
	echo "<input type=hidden name=\"updatetype\" value=$preupdatetype>";
	echo "<input type=hidden name=\"updateid\" value=\"$preid\">";
	echo "<input type=hidden name=\"display_updatepanel\" value=\"$gp_display_updatepanel\">";
	echo "<input type=hidden name=\"yearsel\">";
	echo "<input type=hidden name=\"monthsel\">";
	echo "<input type=hidden name=\"daysel\">";
	if($gp_display_updatepanel==1) $display=""; else $display="none";
	echo "<tr><td id=\"updatepanel\" colspan=2 width=100% valign=top style=\"display: $display; background-color:; border-bottom: 1px $bordercolor dashed; border-top: 1px $bordercolor dashed; border-left: 1px $bordercolor dashed; border-right: 1px $bordercolor dashed;\">";
	
	echo "Details: <input name=\"event\" type=text size=28 value=\"".addslashes(htmlspecialchars($preevent))."\"> ";
	echo "<select name=\"category\" size=1 onchange=\"agenda_par.style.display=((this.value=='agenda')?'':'none');\">";
	reset($categorys);
	for($i=0;$i<count($categorys);$i++)
	{
		$tmp=each($categorys);
		$tmpid=$tmp[0];
	  if($tmpid==$precategory) echo "<option selected value=\"$tmpid\">".$categorys[$tmpid]['label'][$language]."</option>";
	  else echo "<option value=\"$tmpid\">".$categorys[$tmpid]['label'][$language]."</option>";
	}
	echo "</select> ";
	echo "<input type=button name=submitbt value=\"$presubmitname\" onclick=\"checkform();\">";
	if($preupdatetype==2) $inputtype="button"; else $inputtype="hidden";
	echo "<input type=$inputtype value=Clear onclick=\"clearpanel();\">";
	echo "<br>";
	
	if($precategory=="plan") $agenda_par_display="none"; else $agenda_par_display="";
	echo "<span id=\"agenda_par\" style=\"display: $agenda_par_display;\">";
	echo "Begin: <select name=\"startyear\" size=1 onchange=\"autochangeenddate(startyear,startmonth,startday,endyear,endmonth,endday);\">";
	if(!isset($prestartyear)) $prestartyear=$yearsel;
	for($i=$startyear;$i<=$endyear;$i++)
	{
	  if($i==intval($prestartyear)) echo "<option selected value=$i>$i</option>";
	  else  echo "<option value=$i>$i</option>";
	}
	echo "</select>";
	echo "<select name=\"startmonth\" size=1 onchange=\"autochangeenddate(startyear,startmonth,startday,endyear,endmonth,endday); autochangemonlen(startyear,startmonth,startday);\">";
	if(!isset($prestartmonth)) $prestartmonth=$monthsel;
	for($i=1;$i<=12;$i++)
	{
	  if($i==intval($prestartmonth)) echo "<option selected value=$i>$i</option>";
	  else  echo "<option value=$i>$i</option>";
	}
	echo "</select>";
	echo "<select name=\"startday\" size=1 onchange=\"autochangeenddate(startyear,startmonth,startday,endyear,endmonth,endday);\">";
	if(!isset($prestartday)) $prestartday=$daysel;
	for($i=1;$i<=$msellen;$i++)
	{
	  if($i==intval($prestartday)) echo "<option selected value=$i>$i</option>";
	  else  echo "<option value=$i>$i</option>";
	}
	echo "</select> ";
	
	echo "End: <select name=\"endyear\" size=1 onchange=\"onchangeenddate(startyear,startmonth,startday,endyear,endmonth,endday); autochangemonlen(endyear,endmonth,endday);\">";
	if(!isset($preendyear)) $preendyear=$yearsel;
	for($i=$startyear;$i<=$endyear;$i++)
	{
	  if($i==intval($preendyear)) echo "<option selected value=$i>$i</option>";
	  else  echo "<option value=$i>$i</option>";
	}
	echo "</select>";
	echo "<select name=\"endmonth\" size=1 onchange=\"onchangeenddate(startyear,startmonth,startday,endyear,endmonth,endday); autochangemonlen(endyear,endmonth,endday);\">";
	if(!isset($preendmonth)) $preendmonth=$monthsel;
	for($i=1;$i<=12;$i++)
	{
	  if($i==intval($preendmonth)) echo "<option selected value=$i>$i</option>";
	  else  echo "<option value=$i>$i</option>";
	}
	echo "</select>";
	echo "<select name=\"endday\" size=1 onchange=\"onchangeenddate(startyear,startmonth,startday,endyear,endmonth,endday);\">";
	if(!isset($preendday)) $preendday=$daysel;
	for($i=1;$i<=$msellen;$i++)
	{
	  if($i==intval($preendday)) echo "<option selected value=$i>$i</option>";
	  else  echo "<option value=$i>$i</option>";
	}
	echo "</select> ";
	echo "<br>";
	
	echo "Time: <select name=\"hour\" size=1>";
	if(!isset($prehour))
	{
	  $prehour="-1"; //date("G");
	  echo "<option selected value=\"--\">--</option>";
	}
	else  echo "<option value=\"--\">--</option>";
	for($i=0;$i<24;$i++)
	{
	  if($i==$prehour) echo "<option selected value=$i>$i</option>";
	  else echo "<option value=$i>$i</option>";
	}
	echo "</select>:";
	echo "<select name=\"minute\" size=1>";
	if(!isset($preminute))
	{
	  $preminute="-1"; //round(date("i")/10)*10;
	  echo "<option selected value=\"--\">--</option>";
	}
	else  echo "<option value=\"--\">--</option>";
	for($i=0;$i<60;$i+=10)
	{
	  if($i==$preminute) echo "<option selected value=$i>$i</option>";
	  else echo "<option value=$i>$i</option>";
	}
	echo "</select> ";
	
	echo "<select name=\"pdop\" size=1 style=\"display: none;\">";
	echo "</select>";
	echo "<select name=\"dop\" size=1 style=\"display: none;\">";
	echo "</select>";
	if(!isset($predop)) $predop=-1;
	if(!isset($prepdop)) $prepdop=0;
	echo "/<select name=\"period\" size=1 onchange=\"autochangedop(period,dop,pdop,Number($predop),Number($prepdop));\">";
	reset($periods);
	for($i=0;$i<count($periods);$i++)
	{
		$tmp=each($periods);
		$tmpid=strtolower($tmp[0]);
	  if($tmpid==$preperiod) echo "<option selected value=\"$tmpid\">".$periods[$tmpid]['label'][$language]."</option>";
	  else echo "<option value=\"$tmpid\">".$periods[$tmpid]['label'][$language]."</option>";
	}
	echo "</select> ";
	echo "</span>";
	
	echo "Level: <select name=\"level\" size=1>";
	reset($levels);
	for($i=0;$i<count($levels);$i++)
	{
		$tmp=each($levels);
		$tmpid=strtolower($tmp[0]);
	  if($tmpid==$prelevel) echo "<option selected value=\"$tmpid\">".$levels[$tmpid]['label'][$language]."</option>";
	  else echo "<option value=\"$tmpid\">".$levels[$tmpid]['label'][$language]."</option>";
	}
	echo "</select>";
	echo "<br>";
	
	echo "<span style=\"display: none;\">";
	echo "Remind before<select name=\"reminder\" size=1>";
	reset($reminders);
	for($i=0;$i<count($reminders);$i++)
	{
		$tmp=each($reminders);
		$tmpid=strtolower($tmp[0]);
	  if($tmpid==$prereminder) echo "<option selected value=\"$tmpid\">".$reminders[$tmpid]['label'][$language]."</option>";
	  else echo "<option value=\"$tmpid\">".$reminders[$tmpid]['label'][$language]."</option>";
	}
	echo "</select>";
	echo "</span>";

	echo "</td></tr>";
}
echo "<tr><td id=\"eventlist\" colspan=2 width=100% valign=top>";
echo "</td></tr>";
if($_SESSION['permission']==2) echo "</form>";
echo "</table>";
echo "</td></tr></table>";
repaint_calendar($events);

echo "<p>";
$checkdir=$datafile;
include($lastupdatefunc);
echo "</p>";
?>

<script language="javascript">
function click_func(year,month,day,flag)
{
	var datestr=String(year)+'.'+String(month)+'.'+String(day);
<?
if($_SESSION['permission']==2)
{
?>
if(flag==1)
{
	update_schedule.startyear.selectedIndex=year-<?=$startyear?>;
	update_schedule.startmonth.selectedIndex=month-1;
	autochangemonlen(update_schedule.startyear,update_schedule.startmonth,update_schedule.startday);
	update_schedule.startday.selectedIndex=day-1;
	update_schedule.endyear.selectedIndex=year-<?=$startyear?>;
	update_schedule.endmonth.selectedIndex=month-1;
	autochangemonlen(update_schedule.endyear,update_schedule.endmonth,update_schedule.endday);
	update_schedule.endday.selectedIndex=day-1;
}
<?}?>
	var insertstr="<table border=0 width=100%>";
<?
	$eventstr="<tr><td colspan=2 style='font-size: 80%; background-color: $shadowcolor; border-bottom: 1px $bordercolor solid;'><b>".$agenda_label[$language]."</b></td></tr>";
	echo "insertstr=insertstr+\"$eventstr\";\n";
	if($events==null) echo "insertstr=insertstr+\"<tr><td colspan=2><b>--</b></td></tr>\";\n";
?>
	switch(datestr)
	{
<?
reset($events);
for($i=0;$events!=null && $i<count($events);$i++)
{
	$curevent=each($events);
	$eventstamp=$curevent[0];
	$eventdes=$curevent[1];
	$datestr=gmdate("Y",$eventstamp).".".gmdate("n",$eventstamp).".".gmdate("j",$eventstamp);
	echo "case '$datestr':\n";
	if(count($eventdes['id'])==0) echo "insertstr=insertstr+\"<tr><td colspan=2><b>--</b></td></tr>\";\n";
	for($j=0;$j<count($eventdes['id']);$j++)
	{
		$eid=$eventdes['id'][$j];
		$eventstr="<tr><td valign=top width=40><b>".substr($eventdes['time'][$j],0,2).":".substr($eventdes['time'][$j],2)."</b> </td><td> ";
		$eventstr.="<font color=".$levels[$eventdes['level'][$j]]['fontcolor']."><b>";
		$eventstr.=$eventdes['event'][$j];
		$eventstr.="</b></font>";
		if($_SESSION['permission']==2)
		{
			$eventstr.=" <input type=button value=mod onclick=tomodify('$eid') style='font-size: 65%'>";
			$eventstr.="<input type=button value=del onclick=todelete('$eid') style='font-size: 65%'>";
		}
		$eventstr.="</td></tr>";
		echo "insertstr=insertstr+\"$eventstr\";\n";
	}
	echo "break;\n";
}
if($events!=null) echo "default:\n insertstr=insertstr+\"<tr><td colspan=2><b>--</b></td></tr>\";\n";
?>
	}
<?
if(!isset($gp_entrance) || strlen($gp_entrance)<=2 || $_SESSION['entrance']==$gp_entrance)
{
	$eventdes=$events["plan"];
	$eventstr="<tr><td colspan=2 style='font-size: 80%; background-color: $shadowcolor; border-bottom: 1px $bordercolor solid;'><b>".$plan_label[$language]."</b></td></tr>";
	echo "insertstr=insertstr+\"$eventstr\";\n";
	if(count($eventdes['id'])==0) echo "insertstr=insertstr+\"<tr><td colspan=2><b>--</b></td></tr>\";\n";
	for($j=0;$j<count($eventdes['id']);$j++)
	{
		$eid=$eventdes['id'][$j];
		$eventstr="<tr><td valign=top width=40><b>".($j+1).".</b></td><td> ";
		$eventstr.="<font color=".$levels[$eventdes['level'][$j]]['fontcolor']."><b>";
		$eventstr.=$eventdes['event'][$j];
		$eventstr.="</b></font>";
		if($_SESSION['permission']==2)
		{
			$eventstr.=" <input type=button value=mod onclick=tomodify('$eid') style='font-size: 65%'>";
			$eventstr.="<input type=button value=del onclick=todelete('$eid') style='font-size: 65%'>";
		}
		$eventstr.="</td></tr>";
		echo "insertstr=insertstr+\"$eventstr\";\n";
	}
}
?>
	insertstr=insertstr+"</table>";
	eventlist.innerHTML=insertstr;
}
//click_func(<?=$gp_yearsel;?>,<?=$gp_monthsel;?>,<?=$gp_daysel;?>);
click_func(<?=$yearsel;?>,<?=$monthsel;?>,<?=$daysel;?>,0);

function beforegoupdate()
{
	update_schedule.yearsel.value=changedate.yearsel.value;
	update_schedule.monthsel.value=changedate.monthsel.value;
	update_schedule.daysel.value=changedate.daysel.value;
}
function displaypanel(flag)
{
	update_schedule.updatetype.value=0;
	update_schedule.display_updatepanel.value=flag;
	beforegoupdate();
	update_schedule.submit();	
}
function tomodify(id)
{
	update_schedule.updateid.value=id;
	update_schedule.event.value="";
	update_schedule.updatetype.value=2;
	update_schedule.display_updatepanel.value=1;
	beforegoupdate();
	update_schedule.submit();
}
function todelete(id)
{
	if(confirm("Sure to delete it?"))
	{
		update_schedule.updateid.value=id;
		update_schedule.updatetype.value=3;
		beforegoupdate();
		update_schedule.submit();
	}
}
function clearpanel()
{
	update_schedule.updatetype.value=1;
	update_schedule.event.value="";
	update_schedule.submitbt.value="To Add";
}
function autochangemonlen(objyear,objmonth,objday)
{
	switch(Number(objmonth.options[objmonth.selectedIndex].value))
	{
		case 4:
		case 6:
		case 9:
		case 11:
			monthlen=30;
			break;
		case 2:
			monthlen=28;
			break;
		default:
			monthlen=31;
	}
	if(monthlen==28 && Number(objyear.options[objyear.selectedIndex].value)%4==0) monthlen=29;
	if(objday.selectedIndex>=monthlen-1) objday.selectedIndex=monthlen-1;
	objday.length=monthlen;
	for(i=1;i<=monthlen;i++)
	{
		objday.options[i-1].value=i;
		objday.options[i-1].text=i;
	}
}
function autochangeenddate(objyear0,objmonth0,objday0,objyear1,objmonth1,objday1)
{
	if(objyear1.options[objyear1.selectedIndex].value<objyear0.options[objyear0.selectedIndex].value)
	{
		objyear1.selectedIndex=objyear0.selectedIndex;
	}
	if(objyear1.options[objyear1.selectedIndex].value==objyear0.options[objyear0.selectedIndex].value && Number(objmonth1.options[objmonth1.selectedIndex].value)<Number(objmonth0.options[objmonth0.selectedIndex].value))
	{
		objmonth1.selectedIndex=objmonth0.selectedIndex;
		autochangemonlen(objyear1,objmonth1,objday1);
	}
	if(objyear1.options[objyear1.selectedIndex].value==objyear0.options[objyear0.selectedIndex].value && Number(objmonth1.options[objmonth1.selectedIndex].value)==Number(objmonth0.options[objmonth0.selectedIndex].value) && Number(objday1.options[objday1.selectedIndex].value)<Number(objday0.options[objday0.selectedIndex].value))
	{
		objday1.selectedIndex=objday0.selectedIndex;
	}
}
function onchangeenddate(objyear0,objmonth0,objday0,objyear1,objmonth1,objday1)
{
	var popalert=0;
	if(objyear1.options[objyear1.selectedIndex].value<objyear0.options[objyear0.selectedIndex].value)
	{
		objyear1.selectedIndex=objyear0.selectedIndex;
		popalert=1;
	}
	if(objyear1.options[objyear1.selectedIndex].value==objyear0.options[objyear0.selectedIndex].value && Number(objmonth1.options[objmonth1.selectedIndex].value)<Number(objmonth0.options[objmonth0.selectedIndex].value))
	{
		objmonth1.selectedIndex=objmonth0.selectedIndex;
		autochangemonlen(objyear1,objmonth1,objday1);
		popalert=1;
	}
	if(objyear1.options[objyear1.selectedIndex].value==objyear0.options[objyear0.selectedIndex].value && Number(objmonth1.options[objmonth1.selectedIndex].value)==Number(objmonth0.options[objmonth0.selectedIndex].value) && Number(objday1.options[objday1.selectedIndex].value)<Number(objday0.options[objday0.selectedIndex].value))
	{
		objday1.selectedIndex=objday0.selectedIndex;
		popalert=1;
	}
	if(popalert==1)
	{
		alert("The ending date must equal to or later than the beginning date!");
		return;
	}
}
function autochangedop(obj1,obj2,obj3,obj2v,obj3v)
{
	switch(obj1.options[obj1.selectedIndex].value)
	{
		case "week":
		case "2weeks":
			obj3.style.display="none";
			obj3.length=0;

			obj2.length=7;
			for(i=0;i<obj2.length;i++)
			{
				obj2.options[i].value=i;
				obj2.options[i].text=i;
				if(i==obj2v) obj2.options[i].selected=true;
			}		
			obj2.style.display="";
			break;
		case "month":
			obj3.length=2;
			obj3.options[0].value="1";
			obj3.options[0].text="+";
			if(obj3v==1) obj3.options[0].selected=true;
			obj3.options[1].value="-1";
			obj3.options[1].text="-";
			if(obj3v==-1) obj3.options[1].selected=true;
			obj3.style.display="";
			
			obj2.length=28;
			for(i=1;i<=obj2.length;i++)
			{
				obj2.options[i-1].value=i;
				obj2.options[i-1].text=i;
				if(i==obj2v) obj2.options[i-1].selected=true;
			}				
			obj2.style.display="";
			break;
		case "syear":
		case "lyear":
			obj3.length=12;
			for(i=1;i<=obj3.length;i++)
			{
				obj3.options[i-1].value=i;
				obj3.options[i-1].text=i;
				if(i==obj3v) obj3.options[i-1].selected=true;
			}				
			obj3.style.display="";
			
			obj2.length=31;
			for(i=1;i<=obj2.length;i++)
			{
				obj2.options[i-1].value=i;
				obj2.options[i-1].text=i;
				if(i==obj2v) obj2.options[i-1].selected=true;
			}				
			obj2.style.display="";
		  break;
		default:
			obj3.style.display="none";
			obj2.style.display="none";
			obj3.length=0;
			obj2.length=0;
	}
}
autochangedop(update_schedule.period,update_schedule.dop,update_schedule.pdop,Number(<?=$predop;?>),Number(<?=$prepdop;?>));

function checkform()
{
	if((update_schedule.event.value.length)==0) alert("Please input details before submit!");
	else 
	{
		beforegoupdate();
		update_schedule.submit();
	}
}
</script>

</html>
