<?php
function repaint_calendar($events)
{
	global $levels;
	
	if($events==null) return;
	echo "\n<script language=\"javascript\">\n";
	reset($events);
	for($i=0;$i<count($events);$i++)
	{
		$curevent=each($events);
		if($curevent[0]=="selectedevent" || $curevent[0]=="plan") continue;
		$date="cell_".gmdate("Y",$curevent[0])."_".gmdate("n",$curevent[0])."_".gmdate("j",$curevent[0]);
		$curevent=$curevent[1];
		$color=$levels["normal"]['bgcolor'];
		for($j=0;$j<count($curevent['id']);$j++)
		{
			if($curevent['level'][$j]=="important") 
			{
				$color=$levels["important"]['bgcolor'];
				break;
			}
		}
		echo "var cellobj=document.all.namedItem('$date'); if(cellobj!=null) $date.style.backgroundColor='$color';\n";
	}
	echo "</script>\n";
}

function create_datafile($datafile)
{
	if($_SESSION['permission']<2) return -1;
	touch($datafile);
	$h=fopen($datafile,"w");
	if($h==false) return false;
	fwrite($h,$datacover_symbol[0]."\n");
	fwrite($h,"#\n");
	fwrite($h,$datacover_symbol[1]."\n");
	fclose($h);
	return true;
}

function write_data($datafile,$event, $mode, &$errinfo)
{
	global $separator, $datacover_symbol;
	
	if(!file_exists($datafile))
	{
		$res=create_datafile($datafile);
		if($res===false)
		{
			$errinfo="Can't create data file!";
			return false;			
		}
		elseif($res==-1) return false;
	}

	$lines=file($datafile);
	$lines=array_slice($lines,1,count($lines)-2);

	$eventstr=implode($separator,$event)."\n";
	$matched=-1;
	switch($mode)
	{
		case 1: //add
			array_push($lines,$eventstr);
			break;
		case 2: //mod
		case 3: //del
			for($i=0;$i<count($lines);$i++)
			{
				$strs=explode($separator,$lines[$i]);
				if($strs[0]==$event["id"]) 
				{
					$matched=$i;
					break;
				}
			}
			if($matched==-1)
			{
				$errinfo="No matched record!";
				return false;
			}
			if($mode==2)
			{
				$lines[$matched]=$eventstr;
			}
			else array_splice($lines,$matched,1);
			break;
		default:
			$errinfo="Invalid operation!";
			return false;
	}
	
	$h=fopen($datafile,"w");
	if(!$h)
	{
		$errinfo="Can't update data file!";
		return false;
	}
	fwrite($h,$datacover_symbol[0]."\n");
	for($i=0;$i<count($lines);$i++)
	{
		fwrite($h,$lines[$i]);
	}
	fwrite($h,$datacover_symbol[1]."\n");
	fclose($h);
	return true;
}

function read_data($datafile, &$events, &$errinfo, $year=0, $month=0, $monthspan=array(-1,1), $selectedid=null, $selectedstamp=null)
{
	global $separator;
	$monlenarr=array(31,28,31,30,31,30,31,31,30,31,30,31);
	
	if($year==0) $year=date("Y");
	if($month==0) $month=date("n");
	$month0=$month+$monthspan[0];
	$dyear=floor($month0/12);
	if($month0<1)
	{
		$month0=$month0%12;
		$month0=12+$month0;
		$year0=$year-1-$dyear;
	}else $year0=$year;
	$stamp0=gmmktime(0,0,0,$month0,1,$year0);
	$month1=$month+$monthspan[1]+1;
	$dyear=floor(($month1-1)/12);
	if($month1>12)
	{
		$month1=($month1-1)%12;
		$month1=1+$month1;
		$year1=$year+$dyear;
	}else $year1=$year;
	$stamp1=gmmktime(0,0,0,$month1,0,$year1);

	if($selectedstamp!=null)
	{
		for($i=0;$i<count($selectedstamp);$i++)
		{
			if($selectedstamp[$i] >= $stamp0 && $selectedstamp[$i] <= $stamp1)
				array_splice($selectedstamp,$i,1);
		}
	}

	$events=array();
	if(!file_exists($datafile))
	{
		$res=create_datafile($datafile);
		if($res===false)
		{
			$errinfo="Can't create data file!";
			return false;			
		}
		elseif($res==-1) return true;
	}

	$lines=file($datafile);
	if(count($lines)<=3) return true;		

	$dayinfo=new calendar_dayinfo();

	for($i=2;$i<count($lines)-1;$i++)
	{
		$str=explode($separator,trim($lines[$i]));
		$id=$str[0];
		$category=$str[4];
		$startdate=$str[5];
		$enddate=$str[6];
		$startstamp=gmmktime(0,0,0,substr($startdate,4,2),substr($startdate,6,2),substr($startdate,0,4));
		$endstamp=gmmktime(0,0,0,substr($enddate,4,2),substr($enddate,6,2),substr($enddate,0,4));
		
		$doselecteddate=0;
		if($selectedstamp!=null)
		{
			for($j=0;$j<count($selectedstamp);$j++)
			{
				if($selectedstamp[$j]>=$startstamp && $selectedstamp[$j]<=$endstamp)
				{
					$doselecteddate=1;
					break;
				}
			}
		}
		
		if(($startstamp > $stamp1 || $endstamp < $stamp0) && ($selectedid==null || array_search($id,$selectedid)===false) && $category!="plan" && $doselecteddate==0) continue;

		$level=$str[1];
		$share=rawurldecode($str[2]);
		$reminder=$str[3];
		$time=$str[7];
		$dop=$str[8];
		$period=$str[9];
		$event=rawurldecode($str[10]);

		if($selectedid!=null && array_search($id,$selectedid)!==false)
		{
			if(!isset($events["selectedevent"])) $events["selectedevent"]=array("id"=>array() ,"level"=>array() ,"share"=>array() ,"reminder"=>array() ,"category"=>array() ,"startdate"=>array() ,"enddate"=>array() ,"time"=>array() ,"dop"=>array() ,"period"=>array() ,"event"=>array());
			array_push($events["selectedevent"]['id'],$id);
			array_push($events["selectedevent"]['level'],$level);
			array_push($events["selectedevent"]['share'],$share);
			array_push($events["selectedevent"]['reminder'],$reminder);
			array_push($events["selectedevent"]['category'],$category);
			array_push($events["selectedevent"]['startdate'],$startdate);
			array_push($events["selectedevent"]['enddate'],$enddate);
			array_push($events["selectedevent"]['time'],$time);
			array_push($events["selectedevent"]['dop'],$dop);
			array_push($events["selectedevent"]['period'],$period);
			array_push($events["selectedevent"]['event'],$event);
		}
		if($category=="plan")
		{
			if(!isset($events["plan"])) $events["plan"]=array("id"=>array() ,"level"=>array() ,"share"=>array() ,"reminder"=>array() ,"category"=>array() ,"startdate"=>array() ,"enddate"=>array() ,"time"=>array() ,"dop"=>array() ,"period"=>array() ,"event"=>array());
			array_push($events["plan"]['id'],$id);
			array_push($events["plan"]['level'],$level);
			array_push($events["plan"]['share'],$share);
			array_push($events["plan"]['reminder'],$reminder);
			array_push($events["plan"]['category'],$category);
			array_push($events["plan"]['startdate'],$startdate);
			array_push($events["plan"]['enddate'],$enddate);
			array_push($events["plan"]['time'],$time);
			array_push($events["plan"]['dop'],$dop);
			array_push($events["plan"]['period'],$period);
			array_push($events["plan"]['event'],$event);			
		}
		if($category=="plan") continue;
		if(($startstamp > $stamp1 || $endstamp < $stamp0) && $doselecteddate==0) continue;
		$stamps=array();
		if($doselecteddate==1)
		{
			for($j=0;$j<count($selectedstamp);$j++)
			{
				if($selectedstamp[$j]>=$startstamp && $selectedstamp[$j]<=$endstamp)
				{
					array_push($stamps,$selectedstamp[$j]);
				}
			}
			
		}
		else
		{
			$startstamp=max($startstamp,$stamp0);
			$endstamp=min($endstamp,$stamp1);
			for($j=$startstamp;$j<=$endstamp;$j+=86400) array_push($stamps,$j);
		}
		
		if($period=="syear")
		{
			$pos=strpos($dop,".");
			$years=array();
			for($j=0;$j<count($stamps);$j++)
			{
				$curyear=gmdate("Y",$stamps[$j]);
				if(array_search($curyear,$years)===false) array_push($years,$curyear);
			}
			for($j=0;$j<=$years;$j++)
			{
				$curyear=$years[$j];
				$stamp=gmmktime(0,0,0,floor($dop),substr($dop,$pos+1),$curyear);
				if(!isset($events["$stamp"])) $events["$stamp"]=array("id"=>array() ,"level"=>array() ,"share"=>array() ,"reminder"=>array() ,"category"=>array() ,"startdate"=>array() ,"enddate"=>array() ,"time"=>array() ,"dop"=>array() ,"period"=>array() ,"event"=>array());
				array_push($events["$stamp"]['id'],$id);
				array_push($events["$stamp"]['level'],$level);
				array_push($events["$stamp"]['share'],$share);
				array_push($events["$stamp"]['reminder'],$reminder);
				array_push($events["$stamp"]['category'],$category);
				array_push($events["$stamp"]['startdate'],$startdate);
				array_push($events["$stamp"]['enddate'],$enddate);
				array_push($events["$stamp"]['time'],$time);
				array_push($events["$stamp"]['dop'],$dop);
				array_push($events["$stamp"]['period'],$period);
				array_push($events["$stamp"]['event'],$event);
			}
		}
		else
		{
			$account=0;
			for($j=0;$j<count($stamps);$j++)
			//for($j=$startstamp;$j<=$endstamp;$j+=86400)
			{
				$stamp=$stamps[$j];
				$add=0;
				switch($period)
				{
					case "day":
						$add=1;
						break;
					case "week":
						if(intval($dop)==intval(gmdate("w",$stamp))) $add=1;
						break;
					case "2weeks":
						if(intval($dop)==intval(gmdate("w",$stamp))) 
						{
							$account++;
							if($account%2==1) $add=1;
						}
						break;
					case "month":
						if($dop>0)
						{
							if(intval($dop)==intval(gmdate("j",$stamp))) $add=1;
						}
						else
						{
							$monlen=$monlenarr[gmdate("n",$stamp)-1];
							if($monlen==28 && gmdate("Y",$stamp)%4==0) $monlen=29;	
							if(intval($dop)==(gmdate("j",$stamp)-$monlen-1)) $add=1;
						}
						break;
					case "lyear":
						$dayinfo->init3(gmdate("Y",$stamp),gmdate("n",$stamp),date("j",$stamp));
						$lunar=$dayinfo->lunar_date();
						$lunardate=floatval($lunar["Month"].".".$lunar["Day"]);
						if(floatval($dop)==$lunardate) $add=1;
						break;
				}				
				if($add==0) continue;
				if(!isset($events["$stamp"])) $events["$stamp"]=array("id"=>array() ,"level"=>array() ,"share"=>array() ,"reminder"=>array() ,"category"=>array() ,"startdate"=>array() ,"enddate"=>array() ,"time"=>array() ,"dop"=>array() ,"period"=>array() ,"event"=>array());
				array_push($events["$stamp"]['id'],$id);
				array_push($events["$stamp"]['level'],$level);
				array_push($events["$stamp"]['share'],$share);
				array_push($events["$stamp"]['reminder'],$reminder);
				array_push($events["$stamp"]['category'],$category);
				array_push($events["$stamp"]['startdate'],$startdate);
				array_push($events["$stamp"]['enddate'],$enddate);
				array_push($events["$stamp"]['time'],$time);
				array_push($events["$stamp"]['dop'],$dop);
				array_push($events["$stamp"]['period'],$period);
				array_push($events["$stamp"]['event'],$event);
			}
		}
	}

	reset($events);
	for($i=0;$i<count($events);$i++)
	{
		$curevent=each($events);
		if($curevent[0]=="selectedevent" || $curevent[0]=="plan") continue;
		$curevent=$curevent[1];
		if(count($curevent['id'])>1)
			array_multisort($curevent['time'], SORT_ASC, $curevent['level'], SORT_ASC, $curevent['id'], $curevent['share'], $curevent['reminder'], $curevent['category'], $curevent['startdate'], $curevent['enddate'], $curevent['dop'], $curevent['period'], $curevent['event']);
	}
	$curevent=$events['plan'];
	if(count($curevent['id'])>1)
		array_multisort($curevent['level'], SORT_ASC, $curevent['id'], SORT_DESC, $curevent['time'], $curevent['share'], $curevent['reminder'], $curevent['category'], $curevent['startdate'], $curevent['enddate'], $curevent['dop'], $curevent['period'], $curevent['event']);
	
	return true;
}

?>
