<?php

$phptags=array(array("[url]","[/url]","[url]label|href (It's better use relative path if the link is local.)[/url]"),
		array("[img]","[/img]","[img]caption|options (including width, height, align, valign, prefix, and suffix. The last two are designed for caption of the image.)|src[/img]"),
		array("[quote]","[/quote]","[quote][/quote]"),
		array("[ol]","[/ol]","[ol][/ol]"),
		array("[li]","","[li]"),
		array("[b]","[/b]","[b][/b]"),
		array("[i]","[/i]","[i][/i]"),
		array("[sup]","[/sup]","[sup][/sup]"),
		array("[sub]","[/sub]","[sub][/sub]"),
		array("[ref]","[/ref]",""));

function loadphptags($text,$tags,&$numbering,$shadowcolor="#f6f6f6",$specialchars=1)
{
//in PHP.ini: set magic_quotes_gpc = On

	global $rootdir, $webdir, $webhost, $hostnames, $cursubpath, $cachedir, $cachewebdir, $forum_sections, $materialdir, $miniaturedir, $attachflag, $picturesize, $thumbtype, $captionfontsize, $showedpictures, $cachetime;
	$figuresize=$picturesize; //array("width"=>***,"height"=>***);
	$figurescale=1.5;
	$quotes=array("\"","'","&quot;","&apos;");

	if($numbering['figure']==null) $numbering['figure']=0;
	//if(!isset($showedpictures)) $showedpictures=array();
	
	//if($webdir=="") $hostroot=$rootdir;
	//else $hostroot=substr($rootdir,0,strrpos($rootdir,$webdir));
	$hostroot=$rootdir;

	if(is_array($text)) $text=implode("",$text);
	if($specialchars==1) $text=nl2br(htmlspecialchars($text));
	$minpos=strlen($text);
	$tagi=false;
	for($i=0;$i<count($tags);$i++)
	{
		$startpos=0;
		$tag=$tags[$i];
		while(1)
		{
			$pos=strpos($text,$tag[0],$startpos);
			if(!($pos>0 && $text[$pos0-1]=="\\")) break;
			$startpos=$pos+strlen($tag[0]);
		}
		if($pos!==false && $pos < $minpos)
		{
			$minpos=$pos;
			$tagi=$i;
		}
	}
	if($tagi===false) return $text;

	$tag=$tags[$tagi];
	if($tag[1]=="") $tag[1]="<br />"; //for single tag
	$taglen=array(strlen($tag[0]),strlen($tag[1]));
	$startpos=0;
	while(1)
	{
		$pos0=strpos($text,$tag[0],$startpos);
		if($pos0===false) break;
		if($pos0>0 && $text[$pos0-1]=="\\")
		{
			$startpos=$pos0+$taglen[0];
			break;
		}
		$pos1=strpos($text,$tag[1],$pos0+$taglen[0]);
		if($pos1===false) 
		{
			$text=substr_replace($text,"",$pos0,$taglen[0]);
			break;
		}
		$tagstr=substr($text,$pos0+$taglen[0],$pos1-$pos0-$taglen[0]);
		if(strlen(trim(strip_tags($tagstr)))==0)
		{
			$text=substr_replace($text,"",$pos0,$pos1-$pos0+$taglen[1]);
			break;						
		}

		switch(strtolower($tag[0]))
		{
			case "[url]":
				$strs=explode("|",$tagstr);
				if(count($strs)>1)
				{
					for($i=0;$i<count($strs)-1;$i++)
					{
						if($strs[$i][strlen($strs[$i])-1]=="\\")
						{
							$strs[$i]=substr($strs[$i],0,strlen($strs[$i])-1)."|".$strs[$i+1];
							array_splice($strs,$i+1,1);
							break;
						}
					}
				}
				if(count($strs)==1) $strs=array($strs[0],$strs[0]);
				$options="";
				if(count($strs)>=3)
				{
					$options=$strs[1];
					array_splice($strs,1,1);
				}
				$link=addslashes($strs[1]);
				$linkcomp=parse_url($link);
				if(array_search(strtolower($linkcomp['host']),$hostnames)!==false)	
				{
					$linkcomp['host']=$webhost;
					$link=unparse_url($linkcomp);
				}
				$tagstr="<a href=\"$link\" $options>".$strs[0]."</a>";
			break;
			
			case "[img]":
				$strs=explode("|",$tagstr);
				if(count($strs)>1)
				{
					for($i=0;$i<count($strs)-1;$i++)
					{
						if($strs[$i][strlen($strs[$i])-1]=="\\")
						{
							$strs[$i]=substr($strs[$i],0,strlen($strs[$i])-1)."|".$strs[$i+1];
							array_splice($strs,$i+1,1);
							break;
						}
					}
				}
				if(count($strs)==1) $strs=array("",$strs[0]);
				$options="";
				if(count($strs)>=3) 
				{
					$options=$strs[1];
					array_splice($strs,1,1);
				}
				$optarr=array();
				$width="";
				$height="";
				$align="right";
				$valign="";
				$prefix="Figure ";
				$suffix="";
				if($options!="")
				{
					$optarr=explode(" ",$options);
					for($i=0;$i<count($optarr);$i++)
					{
						$opt=$optarr[$i];
						if(strtolower(substr($opt,0,4))=="src=")
						{
							array_splice($optarr,$i,1);
							$i--;
						}
						if(strtolower(substr($opt,0,6))=="width=")
						{
							$width=str_replace($quotes,"",substr($opt,6));
							settype($width,"integer");
							array_splice($optarr,$i,1);
							$i--;
						}
						if(strtolower(substr($opt,0,7))=="height=")
						{
							$height=str_replace($quotes,"",substr($opt,7));
							settype($height,"integer");
							array_splice($optarr,$i,1);
							$i--;
						}
						if(strtolower(substr($opt,0,6))=="align=")
						{
							$align=substr($opt,6);
							array_splice($optarr,$i,1);
							$i--;
						}
						if(strtolower(substr($opt,0,7))=="valign=")
						{
							$valign=substr($opt,7);
							array_splice($optarr,$i,1);
							$i--;
						}
						if(strtolower(substr($opt,0,7))=="prefix=")
						{
							$prefix=str_replace($quotes,"",substr($opt,7));
							array_splice($optarr,$i,1);
							$i--;
						}
						if(strtolower(substr($opt,0,7))=="suffix=")
						{
							$suffix=str_replace($quotes,"",substr($opt,7));
							array_splice($optarr,$i,1);
							$i--;
						}
					}
				}
				if($width=="")
				{
					$imgsize['width']=$figuresize['width'];
				}
				else $imgsize['width']=min($figuresize['width']*$figurescale,$width);
				if($height=="")
				{
					$imgsize['height']=$figuresize['height'];
				}
				else $imgsize['height']=min($figuresize['height']*$figurescale,$height);

				$link=addslashes($strs[1]);
				$minlink=$link;
				//check thumb img here
				$linkcomp=parse_url($link);
				if(array_search(strtolower($linkcomp['host']),$hostnames)!==false)	
				{
					$linkcomp['host']=$webhost;
					$link=unparse_url($linkcomp);
					$minlink=$link;
				}
				$localpic=0;
				if(!isset($linkcomp['host']) || strtolower($linkcomp['host'])==strtolower($webhost))
				{
					if(!isset($linkcomp['host']))	$hostdir=$hostroot."/".$cursubpath."/";
					else $hostdir=$hostroot;
					for($i=0;$i<count($forum_sections);$i++)
					{
						$pos=strpos($linkcomp['path'],"/".$forum_sections[$i]['name']);
						if($pos!==false)
						{
							$tmpstr=substr($linkcomp['path'],$pos+strlen($forum_sections[$i]['name'])+1);
							if($tmpstr[0]!='/') continue;
							//$subdirs=explode("/",$tmpstr);
							$subpos1=strpos($tmpstr,"/".$materialdir);
							if($subpos1===false) continue;
							$subpos2=strpos($tmpstr,"/".$miniaturedir);
							$localpic=1;
							if($subpos2===false || $subpos2<=$subpos1)
							{
								$picfile=substr($tmpstr,$subpos1+strlen($materialdir)+2);
								$extpos=strrpos($picfile,".");
								$picfname=substr($picfile,0,$extpos);
								$tmpos=strpos($picfname,$attachflag[1]);
								if($tmpos!==false) $picfname=substr_replace($picfname,$attachflag[2],$tmpos,3);
								$picfile=$hostdir.$linkcomp['path'];
								$mindir=substr($tmpstr,0,$subpos1+strlen($materialdir)+2).$miniaturedir;
								$minfile=$mindir."/".$picfname.".$thumbtype";
								$mindir=$hostdir.substr($linkcomp['path'],0,$pos+strlen($forum_sections[$i]['name'])+1).$mindir;
								$linkcomp['path']=substr($linkcomp['path'],0,$pos+strlen($forum_sections[$i]['name'])+1).$minfile;
								$minfile=$hostdir.$linkcomp['path'];
								if(!file_exists($minfile))
								{
									if(file_exists($picfile)) 
									{
										$picsize=calpicsize($picfile,$figuresize);
										if(!is_dir($mindir))
										{
											mkdir($mindir);
											touch("$mindir/index.htm");
										}
										if(is_dir($mindir))
										{
											makethumb($picfile,$minfile,$picsize[0],$picsize[1]);
											$minlink=unparse_url($linkcomp);
										}
									}
								}
								if(file_exists($minfile)) $minlink=unparse_url($linkcomp);
								break;
							}
							else
							{
								$picfile=substr($tmpstr,$subpos2+strlen($miniaturedir)+2);
								$extpos=strrpos($picfile,".");
								$picfname=substr($picfile,0,$extpos);
								$tmpos=strpos($picfname,$attachflag[2]);
								if($tmpos!==false) $picfname=substr_replace($picfname,$attachflag[1],$tmpos,3);
								$picfext="";
								$picpath=substr($linkcomp['path'], 0, $pos+strlen($forum_sections[$i]['name'])+1).substr($tmpstr, 0, $subpos1+strlen($materialdir)+2);
								$picdir=$hostdir.$picpath;
								$dh=opendir($picdir);
								if($dh!==false)
								{
									while(($item=readdir($dh))!==false)
									{
										$fname=substr($item,0,strrpos($item,"."));
										if($fname==$picfname)
										{
											$picfext=substr($item,strrpos($item,".")+1);
											break;
										}
									}
									closedir($dh);
								}
								if($picfext!="") 
								{
									$linkcomp['path']=$picpath.$picfname.".$picfext";
									$link=unparse_url($linkcomp);
								}
								break;
							}
						}
					}
					$picpath=parse_url($link);
					$picpath=$picpath['path'];
					$tmpos=strrpos($picpath,"\.\./");
					$picpath=substr($picpath,$tmpos+3);
					array_push($showedpictures,$picpath);
				}
				if($localpic==0)
				{
					//not a local picture
					$picsize=calpicsize($link,$figuresize);
					$minfname=rawurlencode($link).".$thumbtype";
					$minfile="$cachedir/$minfname";
					if(!file_exists($minfile) || (time()-filemtime($minfile))>$cachetime)
					{
						if(!is_dir($cachedir))
						{
							mkdir($cachedir);
							touch("$cachedir/index.htm");
						}
						if(is_dir($cachedir) && makethumb($link,$minfile,$picsize[0],$picsize[1])!==false)
							$minlink="$cachewebdir/".rawurlencode($minfname);
					}
					else $minlink="$cachewebdir/".rawurlencode($minfname);
				}

				$imgsize=calpicsize($minlink,$imgsize);
				array_push($optarr,"width=".$imgsize[0],"height=".$imgsize[1]);
				$options=implode(" ",$optarr);

				$numbering['figure']++;
				$tagstr="<table cellspacing=8 border=0 align=$align valign=$valign><tr><td style=\"font-size: $captionfontsize;\"><a href=\"$link\"><img src=\"$minlink\" $options border=0></a><br><b>$prefix".$numbering['figure']."$suffix</b><i> ".$strs[0]."</i></td></tr></table>";
			break;
			
			case "[b]":
				$tagstr="<b>".$tagstr."</b>";			
			break;
			
			case "[i]":
				$tagstr="<i>".$tagstr."</i>";			
			break;
			
			case "[sup]":
				$tagstr="<sup>".$tagstr."</sup>";			
			break;
			
			case "[sub]":
				$tagstr="<sub>".$tagstr."</sub>";			
			break;
			
			case "[quote]":
				$tagstr="<p><table width=\"96%\" align=\"center\" style=\"margin-top: 10; margin-bottom: 10\"><tr><td style=\"font-size: 75%;\"><b>Quote:</b></td></tr><tr><td><table border=0 cellspacing=4 style=\"border-left: 1px #aaaaaa dashed; border-right: 1px #aaaaaa dashed; border-top: 1px #aaaaaa dashed; border-bottom: 1px #aaaaaa dashed; background-color: $shadowcolor;\"><tr><td style=\"font-size: 75%;\"><i>".$tagstr."</i></td></tr></table></td></tr></table></p>";					
			break;
			
			case "[ol]":
				$tagstr="<ol>".$tagstr."</ol>";			
			break;
			
			case "[li]":
				$tagstr="<li>".$tagstr;			
			break;
			
			default:
				$tagstr="";
		}
		$text=substr_replace($text,$tagstr,$pos0,$pos1-$pos0+$taglen[1]);
	}
	return loadphptags($text,$tags,$numbering,$shadowcolor,0);
}

function unparse_url($urlcomp)
{
	$url="";
	if(isset($urlcomp['scheme'])) $url.=$urlcomp['scheme']."://";
	if(isset($urlcomp['user'])) $url.=$urlcomp['user'].":";
	if(isset($urlcomp['pass'])) $url.=$urlcomp['pass']."@";
	if(isset($urlcomp['host'])) $url.=$urlcomp['host'];
	if(isset($urlcomp['port'])) $url.=":".$urlcomp['port'];
	if(isset($urlcomp['path'])) $url.=$urlcomp['path'];
	if(isset($urlcomp['query'])) $url.="?".$urlcomp['query'];
	if(isset($urlcomp['anchor'])) $url.="#".$urlcomp['anchor'];
	return $url;
}

?>
