<?php
function loadpar($parfile,&$arrcategory,&$arrlevel,&$arrkind,&$arrjournal)
{
	$arrcategory=array();
	$arrlevel=array();
	$arrjournal=array();
	$arrkind=array();
	
	$section=0;
	$lines=file($parfile);
	for($i=0;$i<count($lines);$i++)
	{
		$line=substr($lines[$i],0,strrpos($lines[$i],"."));
		if($line[0]=="#")
		{
			if(strncasecmp(substr($line,1),"category",8)==0)	$section=1;
			else if(strncasecmp(substr($line,1),"level",5)==0)	$section=2;
			else if(strncasecmp(substr($line,1),"journal",7)==0)	$section=3;
			else if(strncasecmp(substr($line,1),"status",6)==0)	$section=4;
		}
		else
		{
			switch($section)
			{
				case 1:
					$str=explode(":",$line);
					for($j=0;$j<count($str);$j++)
					{
						$key=$str[$j][0];
						$arrcategory=array_merge($arrcategory, array($key=>substr($str[$j],1)));
					}
					break;
				case 2:
					$str=explode(":",$line);
					for($j=0;$j<count($str);$j++)
					{
						//$key=substr($str[$j],0,2);
						$key=$str[$j][0];
						$arrlevel=array_merge($arrlevel, array($key=>substr($str[$j],1)));
					}
					break;
				case 3:
					$str=explode(":",$line);
					$key=array_shift($str);
					$arrjournal=array_merge($arrjournal, array("$key"=>$str));
					break;
				case 4:
					$str=explode(":",$line);
					for($j=0;$j<count($str);$j++)
					{
						$key=$str[$j][0];
						$arrkind=array_merge($arrkind, array($key=>substr($str[$j],1)));
					}
					break;
			}
		}
	}
	if($arrcategory==NULL || $arrlevel==NULL || $arrkind==NULL || $arrjournal==NULL)	return(false);
	else	return(true);
}

function loadpubinfo($datafile,$materialdir,&$pubinfo,&$errinfo,$filters=array("0","0","0"))
{
	global $datacover_symbol, $separator;
	$lineunit=9;

	if(!file_exists($datafile))
	{
		$h=fopen($datafile,'w');
		if($h)
		{
			fwrite($h,$datacover_symbol[0]."\n");
			fwrite($h,$datacover_symbol[1]."\n");
			fclose($h);
		}
	}
	if(!file_exists($datafile)) 
	{
		$errinfo="Can't create data file!";
		return false;
	}
	
	if(is_dir($materialdir))	
	{
		//$attachments=scandir($materialdir);
		$attachmentcount=1;//count($attachments);
	}
	else $attachmentcount=-1;
	
	$lines=file($datafile);
	$num=round((count($lines)-2)/$lineunit);

	$id=array();
	$lastmod=array();
	$author=array();
	$title=array();
	$journal=array();
	$volume=array();
	$page=array();
	$pubdate=array();
	$citetime=array();
	$remark=array();
	$rank=array();
	$category=array();
	$level=array();
	$status=array();
	$abstract=array();
	$attachment=array();
	
	if($filters[2]!="0")
	{
		$range=explode("-",$filters[2]);
	}
	for($i=0;$i<$num;$i++)
	{
		$linei=$lineunit*$i+1;
		$str=explode($separator,trim($lines[$linei+1]));

		if($filters[0]!="0")
		{
			if(strpos($filters[0],$str[0])===false) continue;
		}
		if($filters[1]!="0")
		{
			if(strpos($filters[1],$str[1])===false) continue;			
		}
		if(isset($range))
		{
			if($str[2]<$range[0] || $str[2]>$range[1]) continue;
		}
		
		$str=explode($separator,trim($lines[$linei]));
		$thisid=$str[0];
		array_push($id,$str[0]);
		array_push($lastmod,$str[1]);
		$str=explode($separator,trim($lines[$linei+1]));
		array_push($category,$str[0]);
		array_push($level,$str[1]);
		array_push($rank,$str[2]);
		array_push($status,$str[3]);
		array_push($pubdate,$str[4]);
		array_push($citetime,$str[5]);
		$str=explode($separator,trim($lines[$linei+2]));
		array_push($author,$str);
		$str=trim($lines[$linei+3]);
		array_push($title,$str);
		$str=trim($lines[$linei+4]);
		array_push($journal,$str);
		$str=trim($lines[$linei+5]);
		array_push($volume,$str);
		$str=trim($lines[$linei+6]);
		array_push($page,$str);
		$str=trim($lines[$linei+7]);
		array_push($abstract,$str);
		$str=trim($lines[$linei+8]);
		array_push($remark,$str);
	
		$attach=array();	
		if($attachmentcount)
		{
			//for($j=2;$j<$attachmentcount;$j++)
			//{
				//if(fnmatch("$thisid"."_*",$attachments)) array_push($attach,$attachments[$j]);
			//}
			$attach=glob("$materialdir/$thisid"."_*");
			if($attach===false) $attach=array();
			else
			{
				for($j=0;$j<count($attach);$j++)
					$attach[$j]=basename($attach[$j]);
			}
		}
		array_push($attachment,$attach);
	}
	
	$pubinfo=array("id"=>$id,"lastmod"=>$lastmod,"category"=>$category,"level"=>$level
								,"rank"=>$rank,"status"=>$status,"pubdate"=>$pubdate,"citetime"=>$citetime
								,"author"=>$author,"title"=>$title,"journal"=>$journal,"volume"=>$volume
								,"page"=>$page,"abstract"=>$abstract,"attachment"=>$attachment,"remark"=>$remark);
	return true;
}

function writepubinfo($datafile,$pubinfo,$dir,$mode,&$errinfo)
//0: add; 1: mod; 2: del; 3: del file; 4: citation
{
	global $datacover_symbol, $separator;
	$lineunit=9;
	$start=0;
	$publicationinfo=array();

	if(loadpubinfo($datafile,$dir,$publicationinfo,$errinfo)===false) 
	{
		//$errinfo="Load data error!";
		return false;
	}
	$n=array_search($pubinfo['id'],$publicationinfo['id']);
	if($mode>0 && $n===false)
	{
	 	$errinfo="No matched record!";
	 	return false;
	}
	if($mode<2)
	{
		  for($i=0;$i<count($publicationinfo['id']);$i++)
		  {
		  	if($n!==false && $i==$n) continue;
		  	if($pubinfo['title']==$publicationinfo['title'][$i]
		  		&& $pubinfo['journal']==$publicationinfo['journal'][$i]
		  		&& implode($separator,$pubinfo['author'])==implode($separator,$publicationinfo['author'][$i])
		  		&& $pubinfo['volume']==$publicationinfo['volume'][$i])
			{
		  		$errinfo="Duplicate record!";
		  		return false; 
			}
		  }
	}
	elseif($mode==2)
	{
		for($i=0;$i<count($publicationinfo['attachment'][$n]);$i++) 
		{
			if(unlink("$dir/".$publicationinfo['attachment'][$n][$i])===false)
			{
				$errinfo="Can't delete attachments!";
				return false;
			}
		}
	}
	elseif($mode==3)
	{
		if($pubinfo['attachment']==null) 
		{
			$errinfo="No specified file to delete!";
			return false;
		}
		for($i=0;$i<count($pubinfo['attachment']);$i++) 
		{
			if(unlink("$dir/".$pubinfo['attachment'][$i])===false)
			{
				$errinfo="Can't delete the attachments!";
				return false;
			}
		}
	}
		
	switch($mode)
	{
		case 0: //add
		  array_push($publicationinfo['id'],$pubinfo['id']);
		  array_push($publicationinfo['lastmod'],$pubinfo['lastmod']);
		  array_push($publicationinfo['category'],$pubinfo['category']);
		  array_push($publicationinfo['level'],$pubinfo['level']);
		  array_push($publicationinfo['status'],$pubinfo['status']);
		  array_push($publicationinfo['rank'],$pubinfo['rank']);
		  array_push($publicationinfo['pubdate'],$pubinfo['pubdate']);
		  array_push($publicationinfo['citetime'],$pubinfo['citetime']);
		  array_push($publicationinfo['author'],$pubinfo['author']);
		  array_push($publicationinfo['title'],$pubinfo['title']);
		  array_push($publicationinfo['journal'],$pubinfo['journal']);
		  array_push($publicationinfo['volume'],$pubinfo['volume']);
		  array_push($publicationinfo['page'],$pubinfo['page']);
		  array_push($publicationinfo['abstract'],$pubinfo['abstract']);
		  array_push($publicationinfo['remark'],$pubinfo['remark']);
		  break;
		case 1: //mod
		  $publicationinfo['lastmod'][$n]=$pubinfo['lastmod'];
		  $publicationinfo['category'][$n]=$pubinfo['category'];
		  $publicationinfo['level'][$n]=$pubinfo['level'];
		  $publicationinfo['status'][$n]=$pubinfo['status'];
		  $publicationinfo['rank'][$n]=$pubinfo['rank'];
		  $publicationinfo['pubdate'][$n]=$pubinfo['pubdate'];
		  $publicationinfo['citetime'][$n]=$pubinfo['citetime'];
		  $publicationinfo['author'][$n]=$pubinfo['author'];
		  $publicationinfo['title'][$n]=$pubinfo['title'];
		  $publicationinfo['journal'][$n]=$pubinfo['journal'];
		  $publicationinfo['volume'][$n]=$pubinfo['volume'];
		  $publicationinfo['page'][$n]=$pubinfo['page'];
		  $publicationinfo['abstract'][$n]=$pubinfo['abstract'];
		  $publicationinfo['remark'][$n]=$pubinfo['remark'];
		  break;
		case 2: //del
		  if($n>0)
		  {
			  $publicationinfo['id'][$n]=$publicationinfo['id'][0];
			  $publicationinfo['lastmod'][$n]=$publicationinfo['lastmod'][0];
			  $publicationinfo['category'][$n]=$publicationinfo['category'][0];
			  $publicationinfo['level'][$n]=$publicationinfo['level'][0];
		  	$publicationinfo['status'][$n]=$publicationinfo['status'][0];
		  	$publicationinfo['rank'][$n]=$publicationinfo['rank'][0];
		  	$publicationinfo['pubdate'][$n]=$publicationinfo['pubdate'][0];
		  	$publicationinfo['citetime'][$n]=$publicationinfo['citetime'][0];
		  	$publicationinfo['author'][$n]=$publicationinfo['author'][0];
		  	$publicationinfo['title'][$n]=$publicationinfo['title'][0];
		  	$publicationinfo['journal'][$n]=$publicationinfo['journal'][0];
		  	$publicationinfo['volume'][$n]=$publicationinfo['volume'][0];
		  	$publicationinfo['page'][$n]=$publicationinfo['page'][0];
		  	$publicationinfo['abstract'][$n]=$publicationinfo['abstract'][0];
		  	$publicationinfo['remark'][$n]=$publicationinfo['remark'][0];
		  }
		  $start=1;
		  break;
		case 3:
			$publicationinfo['lastmod'][$n]=$pubinfo['lastmod'];
			break;
		case 4:
			$citfile=$pubinfo['citefile'];
			$h=fopen($citfile,'w');
			if(!$h)
			{
				$errinfo="Can't write to citation file!";
				return false;
			}
			for($j=0;$j<count($pubinfo['citepaper']);$j++)
			{
				fwrite($h,$pubinfo['citepaper'][$j]."\n");
			}
			fclose($h);
			$publicationinfo['citetime'][$n]=$pubinfo['citetime'];
			$publicationinfo['lastmod'][$n]=$pubinfo['lastmod'];
			break;
	}
	$h=fopen($datafile,'w');
	if($h)
	{
		fwrite($h,$datacover_symbol[0]."\n");
		for($i=$start;$i<count($publicationinfo['id']);$i++)
		{
			$str=$publicationinfo['id'][$i].$separator.$publicationinfo['lastmod'][$i];
			fwrite($h,"$str\n");
			$str=$publicationinfo['category'][$i].$separator.$publicationinfo['level'][$i]
					.$separator.$publicationinfo['rank'][$i].$separator.$publicationinfo['status'][$i]
					.$separator.$publicationinfo['pubdate'][$i].$separator.$publicationinfo['citetime'][$i];
			fwrite($h,"$str\n");
			$str=implode($separator,$publicationinfo['author'][$i]);
			fwrite($h,"$str\n");
			fwrite($h,$publicationinfo['title'][$i]."\n");
			fwrite($h,$publicationinfo['journal'][$i]."\n");
			fwrite($h,$publicationinfo['volume'][$i]."\n");
			fwrite($h,$publicationinfo['page'][$i]."\n");
			fwrite($h,$publicationinfo['abstract'][$i]."\n");
			fwrite($h,$publicationinfo['remark'][$i]."\n");
		}
		fwrite($h,$datacover_symbol[1]."\n");
		fclose($h);
		return true;
	}
	$errinfo="Can't open data file to write!";
	return false;
}

function uploadfile($loadedfile,$id,$dir,&$errinfo)
{
	global $upload_file_size_max, $upload_timeout, $forbidden_ftype;

	$sizemax=$upload_file_size_max;
	$timeout=$upload_timeout;
	set_time_limit($timeout);
	$file=strtolower($loadedfile['name']);
	$fext=strtolower(substr($file,strrpos($file,".")+1));
	for($i=0;$i<count($forbidden_ftype);$i++)
	{
		$forbidden=strpos($fext,strtolower($forbidden_ftype[$i]));
		if($forbidden!==false)
		{
			$errinfo=".".$forbidden_ftype[$i]." files are forbidden to upload!";
			return false;
		}
	}
  $upfilename="$dir/$id"."_".$file;
  
	if($loadedfile['size']/(1024*1024)>$sizemax)
	{
		$errinfo="Too large to upload!";
 		unlink($loadedfile['tmp_name']);
		set_time_limit(30);
		return false;
	}
	else
	{
		if(!is_dir($dir))
		{
			mkdir($dir);
			touch("$dir/index.htm");
		}
		if(!is_dir($dir))
		{
			$errinfo="Can't create data directory!";
			unlink($loadedfile['tmp_name']);
			set_time_limit(30);
			return false;
		}
		if($loadedfile['size'] <1024) //ļС
		{
			$filesize=$loadedfile['size']."Bytes";
		}
		elseif ($loadedfile['size'] <(1024 * 1024))
		{
			$filesize=strval($loadedfile['size']/1024)."KB";
		}
		else
		{
			$filesize=strval($loadedfile['size']/(1024 * 1024))."MB";
		}
		if(!file_exists($upfilename))
		{
			if(copy($loadedfile["tmp_name"],$upfilename))
			{
				set_time_limit(30);
				return true;
			}
 			$errinfo="Failed to Upload!";
 			unlink($loadedfile['tmp_name']);
 			set_time_limit(30);
 			return false;
 		}
  	$errinfo="The file already exists!";
		unlink($gp_file['tmp_name']);
 		set_time_limit(30); //ָȱʡʱ
 		return false;
  }
}

function formulanalysis($formula)
{
	$res=0;
	$vleft="";
	$vright="";
	$operator=-1;
	$space=0;
	$pos=0;
	$p=$pos;
	$len=strlen($formula);
//echo "formula:$formula<br>";
//echo "len:$len<br>";
	while($p<$len)
	{
		$r=1;
		$symbol=substr($formula,$p,2);
//echo "symbol:$symbol<br>";
		switch($symbol)
		{
			case "&&":
				$symbol=13;
				break;
			case "||":
				$symbol=12;
				break;
			case "==":
				$symbol=11;
				break;
			case "!=":
				$symbol=10;
				break;
			case ">=":
				$symbol=9;
				break;
			case "<=":
				$symbol=8;
				break;
			default:
			switch($symbol[0])
			{
				case "~":
					$symbol=4;
                                        break;
				case ">":
					$symbol=3;
					break;
				case "<":
					$symbol=2;
					break;
				case "(":
					$symbol=1;
					break;
				case " ":
					$symbol=0;
					break;
				default:
					$symbol=-1;
			}
		}
//echo "symbol1:$symbol<br>";
			switch($symbol)
			{
				case -1:
					$p++;
					break;
				case 0:
					$p++;
					//$space++;
					break;
				case 1:
					$p1=$p;
					$n=0;
					$loop=1;
					while($p1<$len && $loop)
					{
						switch($formula[++$p1])
						{
							case "(":
								$n++;
								break;
							case ")":
								if($n==0)	$loop=0;
								else $n--;
								break;
						}
					}
					$subformula=substr($formula,$p+1,$p1-$p-1);
					$res=formulanalysis($subformula);
					$formula=substr($formula,0,$p).$res.substr($formula,$p1+1);
					$len=strlen($formula);
					break;
				default:
				if($operator<1)
				{
					$r=0;
					$vleft=substr($formula,$pos,$p-$pos);
/*
					$p1=0;
					while($vleft[$p1++]==" ");
					$vleft=substr($vleft,$p1-1);
					$p1=strlen($vleft);
                                        while($vleft[--$p1]==" ");
					$vleft=substr($vleft,0,$p1+1);
*/
//echo "vleft:$vleft<br>";
					$operator=$symbol;
					if($operator<5)		$p++;
					else	$p+=2;
					$pos=$p;
				}
			}
		if($r && $operator>1 && ($symbol>1 || $p==$len))
		{
			//if($p==$len-1)	$p++;
			$vright=substr($formula,$pos,$p-$pos);
/*
			$p1=0;
                        while($vright[$p1++]==" ");
			$vright=substr($vright,$p1-1);
			$p1=strlen($vright);
			while($vright[--$p1]==" ");
                        $vright=substr($vright,0,$p1+1);
*/
//echo "vright:$vright<br>";
			switch($operator)
			{
				case 2:
					$res=($vleft<$vright)?1:0;
					break;
				case 3:
					$res=($vleft>$vright)?1:0;
					break;
				case 4:
					$res=(eregi($vright,$vleft))?1:0;
					break;
				case 8:
					$res=($vleft<=$vright)?1:0;
					break;
				case 9:
					$res=($vleft>=$vright)?1:0;
					break;
				case 10:
					$res=($vleft!=$vright)?1:0;
                                        break;
				case 11:
					$res=($vleft==$vright)?1:0;
					break;
				case 12:
					$res=($vleft || $vright)?1:0;
					break;
				case 13:
					$res=($vleft && $vright)?1:0;
					break;
			}
//echo "res:$res<br>";
			if($p==$len)	return($res);
			else
			{
				$subformula=$res.substr($formula,$p);
				return(formulanalysis($subformula));
			}
		}
	}
	return(0);
}
?>
